#import <AppKit/AppKit.h>
#import <ScreenSaver/ScreenSaver.h>
#import <OpenGL/gl.h>

typedef struct
{
	GLfloat h;
	GLfloat v;
}Point2D;

typedef struct
{
	GLfloat x;
	GLfloat y;
	GLfloat z;
}Point3D;

typedef struct
{
	GLfloat top,left,right,bottom,front,back;
}Rect3D;

typedef struct
{

	GLubyte r;
	GLubyte g;
	GLubyte b;
}OGLColorB;


void InitPoints( void );
void Idle(void);
void MovePointRandom( Point3D* p, Point3D* dir, const Rect3D* rBounds2D );
void Draw(void);


//#define Rand(x,y) ((__abs(Random()) % ((y)-(x))) + (x))

#define kDefaultMin 2
#define kDefaultMax 5
#define kSquareSize .01

#define kMaxNumPoints 40
//
//

#define kNumColors 3
OGLColorB colors[ kNumColors ] = 
{
	{255,0,0},
	{0,255,0},
	{0,0,255}
};


@interface GLConnectivity : ScreenSaverView
{
    NSOpenGLView *_view;
    BOOL _initedGL;
    
    Point3D ourPoints[ kMaxNumPoints ];
    Point3D ourDirs[ kMaxNumPoints ];
    Rect3D rBounds3D;
    UInt32 boundsWidth;
    UInt32 boundsHeight;
    unsigned long numPoints;

    long minSpeed;
    long maxSpeed;

}
@end
