/* GLMorph.h created by epeyton on Thu 03-Dec-1998 */

#import <AppKit/AppKit.h>
#import <ScreenSaver/ScreenSaver.h>
#import <OpenGL/gl.h>

#define MAX_PARTICLES 100
#define MAX_CHILDREN 10

Boolean fireworksMode = 1;
Boolean stereo = 1;
Boolean blueGlasses = 0;

#define degToRad 3.14159/180
#define radToDeg 180/3.14159

typedef struct
{
	float x,y,z;
} vec_3;

typedef struct
{
	vec_3 pos;
	vec_3 vel;
	int dead;
	float life;
} child_p;

typedef struct
{
	float	r;
	float	g;
	float	b;
	
	vec_3	pos;
	vec_3	vel;
	float	yr;
	float	yv;
	float	bobv;	
	float	boba;
	float	rad;
	float	spawnt;
	
	vec_3 gravity;
	float child_maxlife;
	child_p child[MAX_CHILDREN];
            
} particles;

@interface GLParticles : ScreenSaverView
{        
    NSOpenGLView *_view;
    BOOL _initedGL;
    
    int texture;
    float xrot,yrot;
    
    particles *particle[MAX_PARTICLES];
    int num_particles;
    vec_3 camera;
    float last;
    vec_3 star[100];
    
        id window;
        id typeMatrix;
        id stereoCheck;
        id blueGreenCheck;

}

- (void)closeSheet:(id)sender;
- (void)updateSelections:sender;

@end


