#import <AppKit/AppKit.h>
#import <ScreenSaver/ScreenSaver.h>
#import <OpenGL/gl.h>

#define Scale4Window               0.1
#define Scale4Iconic               0.07

#define one_third                  0.3333333333333333333

#define dirNone -1
#define dirUP 0
#define dirDOWN 1
#define dirLEFT 2
#define dirRIGHT 3
#define dirNEAR 4
#define dirFAR 5

#define HCELLS 33
#define VCELLS 25
#define DEFINEDCOLORS 7
#define elbowradius 0.5


typedef struct {
#if defined( MESA ) && defined( SLOW )
	int         flip;
#endif
	GLint       WindH, WindW;
	int         Cells[HCELLS][VCELLS][HCELLS];
	int         usedcolors[DEFINEDCOLORS];
	int         directions[6];
	int         ndirections;
	int         nowdir, olddir;
	int         system_number;
	int         counter;
	int         PX, PY, PZ;
	int         number_of_systems;
	int         system_type;
	int         system_length;
	int         turncounter;
	float      *system_color;
	GLfloat     initial_rotation;
	GLuint      valve, bolts, betweenbolts, elbowbolts, elbowcoins;
	GLuint      guagehead, guageface, guagedial, guageconnector;
        int	    isWireframe, isMono;
} pipesstruct;


@interface GLPipes : ScreenSaverView
{
    id resolutionSlider;

    id rotatePipes;
    id defineLevel;
    id tightTurns;
    id closeUp;
    
    id window;
    
    NSOpenGLView *_view;
    BOOL _initedGL;
    
    pipesstruct 	*pp;


}

- (void)updateSelections:(id)sender;
- (void)closeSheet:(id)sender;

@end
