//
//  SpiroScales.m
//  SpiroScales
//
//  Created by bbum on Tue Oct 03 2000.
//  Copyright (c) 2000 Friday Artworks. All rights reserved.
//

#import <AppKit/AppKit.h>
#import <ScreenSaver/ScreenSaver.h>

#import "SpiroScales.h"

@implementation SpiroScales

- (void)animateOneFrame
{
    NSPoint mp;
    float mx, my;
    float xi, yi;
    float modx, mody;

    pp=p; p=n;
    n=(n+1)%(NUMLINES-1);

    mp = [[self window] mouseLocationOutsideOfEventStream];
    mx = mp.x;
    my = mp.y;

    if (modifiedTracking) {
        baseX = baseX + ((mx - oldx) * 25.0);
        baseY = baseY + ((my - oldy) * 25.0);
    } else {
        modx = ((mx-midx)/urx)*15.0;
        mody = ((my-midy)/ury)*15.0;
    }
    
    xi = baseX + modx;
    yi = baseY + mody;

    if((count++>500) && (((mx != oldx) && (my != oldy)) || (count>30000))){
        count=0;
	[[NSColor blackColor] set];
	NSRectFill([self bounds]);
    }
    oldx=mx; oldy=my;


    t1[n]=t1[p]+0.2*xi; if(t1[n]>(2*PI)) t1[n]-=(2*PI);
    t2[n]=t2[p]+0.2*yi; if(t2[n]>(2*PI)) t2[n]-=(2*PI);
    t3[n]=t2[p]+0.01;   if(t3[n]>(2*PI)) t3[n]-=(2*PI);

    x1[n]=(cos(t1[n])*s1) + (cos(t2[n])*s3) + midx;
    yc1[n]=(sin(t1[n])*s2) + (sin(t2[n])*s4) + midy;

    [[NSColor colorWithDeviceRed: (cos(t1[n])+1.0)/2.0 green: (cos(t2[n])+1.0)/2.0 blue:(cos(t3[n])+1.0)/2.0 alpha: 1.0] set];

    {
	NSBezierPath *path = [NSBezierPath bezierPath];
        
	[path moveToPoint: NSMakePoint(x1[pp], yc1[pp])];
	[path lineToPoint: NSMakePoint(x1[p], yc1[p])];
	[path lineToPoint: NSMakePoint(x1[n], yc1[n])];
	[path closePath];
	[path fill];
    }
}

- (id)initWithFrame:(NSRect)frameRect isPreview:(BOOL)preview
{
    if (![super initWithFrame:frameRect isPreview:preview]) return nil;
    
    [self allocateGState];
    srandom(time(0));
    
    [self setAnimationTimeInterval:0.0];

    [self newSize];
    return self;
}

- (void)setFrameSize:(NSSize)newSize
{
    [super setFrameSize:newSize];
    [self newSize];
}

- newSize
{
    int jkl;

    urx=[self bounds].size.width;
    ury=[self bounds].size.height;

    modifiedTracking = NO;

    midx=urx/2;
    midy=ury/2;
    
    baseX = baseY = 0.0;

    n = 0;
    t = 0;

    // phases of the three points;
    p1=0;
    p2=(4*PI)/3;
    p3=(2*PI)/3;

    // starting angle of each point;
    t1[0]=0;
    t2[0]=p2;
    t3[0]=p3;

    for(jkl=0;jkl<NUMLINES;jkl++){
        x1[jkl]=midx;
        yc1[jkl]=midy;
    }

    // s1 and s2 should define an oval that takes up middle 75% of the screen
    s1 = midx*0.5; s2 = midy*0.5;
    s3 = midx*0.5; s4 = midy*0.5;

    // line per is the percentage back that erase steps
    lper=NUMLINES-5;

    n=lper;
    p=(lper/3)*2;
    pp=(lper/3);
    return self;
}

- (void)drawRect:(NSRect)rects
{
    [[NSColor blackColor] set];
    NSRectFill(rects);
}

// override these so mouse movement won't unsave screen
- (void)mouseEntered:(NSEvent *)theEvent;
{
}
- (void)mouseExited:(NSEvent *)theEvent;
{
}

- (void)flagsChanged:(NSEvent *)theEvent
{
    if ([theEvent modifierFlags] & NSCommandKeyMask) {
        // this SHOULD work... but it doesn't
            modifiedTracking = !modifiedTracking;
    } else {
        if ([theEvent keyCode] == 55) { // why???
            modifiedTracking = !modifiedTracking;
            return;
        }
        [super flagsChanged: theEvent];
    }
}

// enables the Configure button...
- (BOOL) hasConfigureSheet {
    return YES;
}

- (NSWindow*)configureSheet
{
    if (configureSheet == nil)
        [NSBundle loadNibNamed:@"ConfigureSheet" owner:self];
    return configureSheet;
}

- (IBAction)closeSheet:(id)sender;
{
    [NSApp endSheet:configureSheet];
}

@end
