#import "SproingeeView.h"
#import "sproingies.c"
#import "sproingiewrap.c"

@implementation SproingeeView

- (id)initWithFrame:(NSRect)frameRect isPreview:(BOOL)preview
{
    self = [super initWithFrame:frameRect isPreview:preview];
    
    si = (sp_instance *) malloc(sizeof (sp_instance));

    si->positions = 0x0;

    if (self) {		
	NSOpenGLPixelFormatAttribute attribs[] =
        {	NSOpenGLPFAAccelerated,
		NSOpenGLPFADepthSize, 16,
		NSOpenGLPFAMinimumPolicy,
		NSOpenGLPFAClosestPolicy,
                0
        };
	
	NSOpenGLPixelFormat *format = [[[NSOpenGLPixelFormat alloc] initWithAttributes:attribs] autorelease];
		
        _view = [[[NSOpenGLView alloc] initWithFrame:NSZeroRect pixelFormat:format] autorelease];
        [self addSubview:_view];
    }

    return self;
}

- (void)dealloc
{
    free(si);
    [_view removeFromSuperview];
    [super dealloc];
}

- (void)setFrameSize:(NSSize)newSize
{
    [super setFrameSize:newSize];
    [_view setFrameSize:newSize];
    _initedGL = NO;

}

- (void)stopAnimation
{	
    _initedGL = NO;
    [super stopAnimation];
}

- (void)animateOneFrame
{
    [[_view openGLContext] makeCurrentContext];
    if (!_initedGL) {
        init_sproingies(si);
	ReshapeSproingies((int)[self frame].size.width, (int)[self frame].size.height);

        _initedGL = YES;
    }

    draw_sproingies(si);

    return;
}


- (BOOL)hasConfigureSheet { return NO; }
- (NSWindow*)configureSheet { return nil; }

- (void)closeSheet:(id)sender
{
    [NSApp endSheet:nil];
}

@end
