#import "GLSuperquadrics.h"

#import "superquadrics.c"


@implementation GLSuperquadrics	
- (id)initWithFrame:(NSRect)frameRect isPreview:(BOOL)preview
{
    
    ss = (superquadricsstruct *) malloc(sizeof (superquadricsstruct));

    ss->mono = 0;

    self = [super initWithFrame:frameRect isPreview:preview];
    if (self) {
	NSOpenGLPixelFormatAttribute attribs[] =
        {	NSOpenGLPFAAccelerated,
		NSOpenGLPFADepthSize, 16,
		NSOpenGLPFAMinimumPolicy,
		NSOpenGLPFAClosestPolicy,
                0
        };
	
	NSOpenGLPixelFormat *format = [[[NSOpenGLPixelFormat alloc] initWithAttributes:attribs] autorelease];
		
        _view = [[[NSOpenGLView alloc] initWithFrame:NSZeroRect pixelFormat:format] autorelease];
		
        [self addSubview:_view];
    }
    

    return self;
}

- (void)dealloc
{
    [_view removeFromSuperview];
    free(ss);
    [super dealloc];
}

- (void)setFrameSize:(NSSize)newSize
{
    [super setFrameSize:newSize];
    [_view setFrameSize:newSize];
    _initedGL = NO;

}


- (void)stopAnimation
{
    _initedGL = NO;
    [super stopAnimation];
    return;
}

- (void)animateOneFrame
{
    [[_view openGLContext] makeCurrentContext];
    if (!_initedGL) {
        InitSuperquadrics(0,0,20,40,spinspeed, ss);
        ReshapeSuperquadrics((int)[self frame].size.width, (int)[self frame].size.height);
        DisplaySuperquadrics(ss);

        _initedGL = YES;
    }
        draw_superquadrics(ss);
    
    return;
}

- (BOOL)hasConfigureSheet { return NO; }
- (NSWindow*)configureSheet { return nil; }


@end
